<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: src/ServoBehaviours.h Source File</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ServoBehaviours.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_servo_behaviours_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef SERVO_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define SERVO_BEHAVIOUR_h</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;Arduino.h&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_behaviours_8h.html">Behaviours.h</a>&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;Servo.h&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_servo_go_to.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_servo_go_to.html">ServoGoTo</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;{</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    Servo _servo;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="class_servo_go_to.html#ac8b82631935821c8850792fdd1856f1f">   21</a></span>&#160;    <a class="code" href="class_servo_go_to.html#ac8b82631935821c8850792fdd1856f1f">ServoGoTo</a>(Servo servo, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;GoTo&quot;</span>);</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_servo_go_to.html#a13ec355b036a947e216f32db3d876135">   22</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_servo_go_to.html#a13ec355b036a947e216f32db3d876135">args</a>();</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_servo_go_to.html#a2947d36917cfa921fa20f6154e0f9fbb">   23</a></span>&#160;    String <a class="code" href="class_servo_go_to.html#a2947d36917cfa921fa20f6154e0f9fbb">start</a>(String <a class="code" href="class_servo_go_to.html#a13ec355b036a947e216f32db3d876135">args</a>);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;};</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_servo_wiggle.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_servo_wiggle.html">ServoWiggle</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    Servo _servo;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">int</span> _start_time = 0;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">int</span> _wiggle_time = 300;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">int</span> _num_wiggles = 5;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">int</span> _wiggles = 0;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">int</span> _wiggle_angle = 0;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="comment">//Calculate wiggle time by multiplying the angle by this...</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">int</span> _wiggle_factor = 5;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_servo_wiggle.html#a74b65ac2d20091945edeea1d0858b9ab">   41</a></span>&#160;    <a class="code" href="class_servo_wiggle.html#a74b65ac2d20091945edeea1d0858b9ab">ServoWiggle</a>(Servo servo, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> = <span class="stringliteral">&quot;Wiggle&quot;</span>, <span class="keywordtype">int</span> slowness=3);</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_servo_wiggle.html#a10764f7adcfede311818328e042b65a1">   42</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_servo_wiggle.html#a10764f7adcfede311818328e042b65a1">args</a>();</div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_servo_wiggle.html#aad37514650c225f3307c8a93a1036995">   43</a></span>&#160;    String <a class="code" href="class_servo_wiggle.html#aad37514650c225f3307c8a93a1036995">start</a>(String <a class="code" href="class_servo_wiggle.html#a10764f7adcfede311818328e042b65a1">args</a>);</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="class_servo_wiggle.html#ad4c8bf0c71ab975aaac98ad9b879094a">   44</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_servo_wiggle.html#ad4c8bf0c71ab975aaac98ad9b879094a">update</a>();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;};</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="class_servo_go_and_return.html">   52</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_servo_go_and_return.html">ServoGoAndReturn</a> : <span class="keyword">public</span> <a class="code" href="class_behaviour.html">Behaviour</a></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    Servo _servo;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">int</span> _start_angle = 0;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">int</span> _end_angle = 180;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">int</span> _delay = 30;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">int</span> _num_rotations = 1;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">int</span> _rotations = 0;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">int</span> _pause = 500;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_servo_go_and_return.html#abb92506ce4f6e0d7c67353df9d099489">   63</a></span>&#160;    <a class="code" href="class_servo_go_and_return.html#abb92506ce4f6e0d7c67353df9d099489">ServoGoAndReturn</a>(Servo servo, String <a class="code" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a>=<span class="stringliteral">&quot;GoAndReturn&quot;</span>, <span class="keywordtype">int</span> delay=30, <span class="keywordtype">int</span> pause=500, <span class="keywordtype">int</span> start_angle = 2, <span class="keywordtype">int</span> end_angle=178 );</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="class_servo_go_and_return.html#afc4fdd44cae56c9e239391fc819f5740">   64</a></span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="class_servo_go_and_return.html#afc4fdd44cae56c9e239391fc819f5740">args</a>();</div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="class_servo_go_and_return.html#a04dcc4eb914a339003b5d04927a83695">   65</a></span>&#160;    String <a class="code" href="class_servo_go_and_return.html#a04dcc4eb914a339003b5d04927a83695">start</a>(String <a class="code" href="class_servo_go_and_return.html#afc4fdd44cae56c9e239391fc819f5740">args</a>);</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="class_servo_go_and_return.html#a24a373d01dad0729b75ffab97f673202">   66</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_servo_go_and_return.html#a24a373d01dad0729b75ffab97f673202">update</a>();</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;};</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="a_behaviours_8h_html"><div class="ttname"><a href="_behaviours_8h.html">Behaviours.h</a></div><div class="ttdoc">Functionality for block behaviours.</div></div>
<div class="ttc" id="aclass_behaviour_html"><div class="ttname"><a href="class_behaviour.html">Behaviour</a></div><div class="ttdoc">Parent class for all other behaviours.</div><div class="ttdef"><b>Definition:</b> Behaviours.h:20</div></div>
<div class="ttc" id="aclass_behaviour_html_a766009be6f0ed1acd74d4ba5c138a7bd"><div class="ttname"><a href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">Behaviour::name</a></div><div class="ttdeci">virtual String name()</div></div>
<div class="ttc" id="aclass_servo_go_and_return_html"><div class="ttname"><a href="class_servo_go_and_return.html">ServoGoAndReturn</a></div><div class="ttdoc">Behaviour that sets a servo to an angle before returning its position back to zero,...</div><div class="ttdef"><b>Definition:</b> ServoBehaviours.h:53</div></div>
<div class="ttc" id="aclass_servo_go_and_return_html_a04dcc4eb914a339003b5d04927a83695"><div class="ttname"><a href="class_servo_go_and_return.html#a04dcc4eb914a339003b5d04927a83695">ServoGoAndReturn::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_servo_go_and_return_html_a24a373d01dad0729b75ffab97f673202"><div class="ttname"><a href="class_servo_go_and_return.html#a24a373d01dad0729b75ffab97f673202">ServoGoAndReturn::update</a></div><div class="ttdeci">void update()</div></div>
<div class="ttc" id="aclass_servo_go_and_return_html_abb92506ce4f6e0d7c67353df9d099489"><div class="ttname"><a href="class_servo_go_and_return.html#abb92506ce4f6e0d7c67353df9d099489">ServoGoAndReturn::ServoGoAndReturn</a></div><div class="ttdeci">ServoGoAndReturn(Servo servo, String name=&quot;GoAndReturn&quot;, int delay=30, int pause=500, int start_angle=2, int end_angle=178)</div></div>
<div class="ttc" id="aclass_servo_go_and_return_html_afc4fdd44cae56c9e239391fc819f5740"><div class="ttname"><a href="class_servo_go_and_return.html#afc4fdd44cae56c9e239391fc819f5740">ServoGoAndReturn::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_servo_go_to_html"><div class="ttname"><a href="class_servo_go_to.html">ServoGoTo</a></div><div class="ttdoc">Behaviour that sets a servo to an angle specified as its argument.</div><div class="ttdef"><b>Definition:</b> ServoBehaviours.h:17</div></div>
<div class="ttc" id="aclass_servo_go_to_html_a13ec355b036a947e216f32db3d876135"><div class="ttname"><a href="class_servo_go_to.html#a13ec355b036a947e216f32db3d876135">ServoGoTo::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_servo_go_to_html_a2947d36917cfa921fa20f6154e0f9fbb"><div class="ttname"><a href="class_servo_go_to.html#a2947d36917cfa921fa20f6154e0f9fbb">ServoGoTo::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_servo_go_to_html_ac8b82631935821c8850792fdd1856f1f"><div class="ttname"><a href="class_servo_go_to.html#ac8b82631935821c8850792fdd1856f1f">ServoGoTo::ServoGoTo</a></div><div class="ttdeci">ServoGoTo(Servo servo, String name=&quot;GoTo&quot;)</div></div>
<div class="ttc" id="aclass_servo_wiggle_html"><div class="ttname"><a href="class_servo_wiggle.html">ServoWiggle</a></div><div class="ttdoc">Behaviour that wiggles a servo with the sweep angle specified as its argument.</div><div class="ttdef"><b>Definition:</b> ServoBehaviours.h:30</div></div>
<div class="ttc" id="aclass_servo_wiggle_html_a10764f7adcfede311818328e042b65a1"><div class="ttname"><a href="class_servo_wiggle.html#a10764f7adcfede311818328e042b65a1">ServoWiggle::args</a></div><div class="ttdeci">char * args()</div></div>
<div class="ttc" id="aclass_servo_wiggle_html_a74b65ac2d20091945edeea1d0858b9ab"><div class="ttname"><a href="class_servo_wiggle.html#a74b65ac2d20091945edeea1d0858b9ab">ServoWiggle::ServoWiggle</a></div><div class="ttdeci">ServoWiggle(Servo servo, String name=&quot;Wiggle&quot;, int slowness=3)</div></div>
<div class="ttc" id="aclass_servo_wiggle_html_aad37514650c225f3307c8a93a1036995"><div class="ttname"><a href="class_servo_wiggle.html#aad37514650c225f3307c8a93a1036995">ServoWiggle::start</a></div><div class="ttdeci">String start(String args)</div></div>
<div class="ttc" id="aclass_servo_wiggle_html_ad4c8bf0c71ab975aaac98ad9b879094a"><div class="ttname"><a href="class_servo_wiggle.html#ad4c8bf0c71ab975aaac98ad9b879094a">ServoWiggle::update</a></div><div class="ttdeci">void update()</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
